You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.
tdebase/r14-xdg-update

548 lines
23 KiB

#!/bin/sh
#
# A script to perform R14.0.0 XDG compliance updates.
# This script should be needed to run only once, but corner cases
# and file/directory permissions could cause incomplete updates.
# TODO: How to handle environments where files/directories are locked
# administratively or are owned by root and can't be updated.
# The nominal validation checks in this script provide some notice
# but no direct remedy.
# TODO: How to update profile directories not named $HOME/.trinity and $TDEHOME
# is not yet declared when running this script.
Wait_For_Response () {
unset response
# -r Backslash does not act as an escape character.
# -p Display "PROMPT" without a trailing newline, before attempting to read any input.
while true; do
read -r -p "$1 (y/n): " yn
case $yn in
[Yy]* ) response=y; break;;
[Nn]* ) response=n; break;;
* ) echo "Please answer yes (y/Y) or no (n/N).";;
esac
done
}
Proceed_From_Response () {
if [ "$response" = "n" -o "$response" = "N" ]; then
echo "Exiting."
echo
exit 0
else
echo "Continuing."
echo
fi
}
Display_Message () {
if [ "$USER_DIR" = "$HOME" ] && [ "$DISPLAY" != "" ]; then
printf "%b" "$MESSAGE" | xmessage -center -file - > /dev/null 2>/dev/null
else
printf "%b" "$MESSAGE"
fi
}
Message_Prefix () {
if [ "$USER_DIR" = "$HOME" ] && [ "$DISPLAY" != "" ]; then
printf "%s" "[r14-xdg-update] "
fi
}
Validation_Failure () {
Display_Message "$MESSAGE"
if [ "$KDEGLOBALS_KEY_VALUE" = "" ]; then
KDEGLOBALS_KEY_VALUE="$TEST_NUM"
else
KDEGLOBALS_KEY_VALUE="$KDEGLOBALS_KEY_VALUE;$TEST_NUM"
fi
}
# Main script:
SCRIPT_NAME="`basename \`readlink -f $0\``"
# Allow forced execution of this script regardless of the kdeglobals setting
# and allow passing a user home directory as a positional parameter.
if [ "$#" -eq "2" ]; then
if [ "$1" = "force" ] || [ "$2" = "force" ]; then
FORCE="true"
fi
if [ "$1" != "force" ]; then
USER_DIR="$1"
elif [ "$2" != "force" ]; then
USER_DIR="$2"
fi
elif [ "$#" -eq "1" ]; then
if [ "$1" = "force" ]; then
FORCE="true"
else
USER_DIR="$1"
fi
fi
unset KDEGLOBALS_KEY_VALUE
WARNING_MESSAGE="Trinity R14 XDG compliance updates will not be performed.\n\nWithout R14 XDG compliance updates, some Trinity apps will fail to\nfunction properly.\n\nFailures include the following:\n\n* Many left-side icon lists will not populate,\n such as the Panel and Konqueror configuration dialogs.\n\n* User-defined keyboard shortcuts fail (khotkeysrc).\n System defined shortcuts remain functional.\n\n* User-defined app preferences fail (profilerc).\n\n* Konqueror navigation/sidebar panel won't open.\n\n* User-defined konqueror service menus, kicker customization,\n* konqueror sidebar, Recent Documents list fail.\n\nPlease exercise appropriate action.\n"
# As the user should not be logged into a Trinity session when running
# this script, or an administrator might run this script remotely, the
# $TDEHOME variable might not be set or knowable from within this script.
# We presume $USER_DIR/.trinity and provide a way to pass an environment
# variable to change that location.
USER_DIR=${USER_DIR:-"$HOME"}
if [ "$USER_DIR" != "$HOME" ]; then
PROFILE_DIR=${PROFILE_DIR:-"$USER_DIR/.trinity"}
elif [ "$TDEHOME" = "" ]; then
PROFILE_DIR=${PROFILE_DIR:-"$USER_DIR/.trinity"}
else
PROFILE_DIR="$TDEHOME"
fi
if [ ! -d "$PROFILE_DIR" ]; then
MESSAGE="Warning! Unable to find the user profile directory $PROFILE_DIR.\n\nCheck permissions, paths, and typing.\n\n${WARNING_MESSAGE}"
# Are we in X? Display an X dialog explaining breakage.
if [ "$USER_DIR" = "$HOME" ] && [ "$DISPLAY" != "" ]; then
printf "%b" "$MESSAGE" | xmessage -center -file - -buttons Continue,Quit > /dev/null 2>/dev/null
if [ "$?" = "102" ]; then
# User selected the Quit button: quit this script.
unset PROFILE_DIR
fi
else
Message_Prefix
printf "%b" "$MESSAGE"
fi
exit 1
fi
CACHE_DIR="$PROFILE_DIR/cache-`uname -n`"
# The binaries for TDE are located in the same place as this script.
# To determine that location use the following method rather than presuming
# the existence of $TDEDIR. That environment variable might not be
# defined or defined to point to KDE4 binaries.
BIN_DIR="`dirname \`readlink -f $0\``"
if [ -x $BIN_DIR/tde-config ]; then
TDEDIR=${BIN_DIR%/bin}
else
MESSAGE="Unable to determine the TDE bin directory, where this script should be installed."
# Are we in X? Display an X dialog explaining breakage.
if [ "$USER_DIR" = "$HOME" ] && [ "$DISPLAY" != "" ]; then
printf "%b" "$MESSAGE" | xmessage -center -file - -buttons Continue,Quit > /dev/null 2>/dev/null
if [ "$?" = "102" ]; then
# User selected the Quit button: quit this script.
unset PROFILE_DIR
exit 1
fi
else
Message_Prefix
printf "%b" "$MESSAGE\n\n${WARNING_MESSAGE}"
fi
exit 1
fi
unset BIN_DIR
Message_Prefix
echo "Performing a profile update for Trinity release R14 XDG compliance."
Message_Prefix
echo "To run this script against a different user directory, or automated"
Message_Prefix
echo "from within another script, pass the directory path as a parameter."
Message_Prefix
echo "For example: r14-xdg-update /home/user_dir"
Message_Prefix
echo "Use the user home directory and not the profile directory."
Message_Prefix
echo "User directory: $USER_DIR"
Message_Prefix
echo "Profile directory: $PROFILE_DIR"
if [ "$USER_DIR" != "$HOME" ]; then
Message_Prefix
echo "Root (admin) privileges might be required to run this script"
Message_Prefix
echo "against other user directories."
Message_Prefix
echo "This script is being run against $USER_DIR."
Message_Prefix
echo "Your normal user directory is $HOME."
fi
# Do not update when $TDEHOME is a sym link to another profile directory. Trinity should have
# full reign within its own profile directory (limited to administrative locking), but the error
# check is a conservative approach.
TDEHOME_LINK="`readlink \"$PROFILE_DIR\"`"
if [ "$TDEHOME_LINK" != "" ]; then
# Force this entry to ensure the updates eventually are performed should the user copy the
# original kdeglobals file into a new Trinity profile.
# $TDEDIR/bin/kwriteconfig --file "$PROFILE_DIR/share/config/kdeglobals" --group "R14 XDG Updates" --key Updated --type bool 'false'
# Are we in X? Display an X dialog explaining breakage.
if [ "$USER_DIR" = "$HOME" ] && [ "$DISPLAY" != "" ]; then
echo "[r14-xdg-update] Warning! The profile directory $PROFILE_DIR is a" 1>&2
echo " sym link to $TDEHOME_LINK!" 1>&2
echo " R14 updates will not be performed because Trinity needs its own" 1>&2
echo " separate profile directory." 1>&2
echo " Without R14 updates some Trinity apps will fail to function correctly." 1>&2
fi
MESSAGE="Oops! The profile directory $PROFILE_DIR is a sym link to $TDEHOME_LINK.\n\n${WARNING_MESSAGE}\nPossible remedies:\n\n* Contact your system administrator.\n\n* Break the sym link to force creating a fresh Trinity profile.\n\n* Use the migratekde3 script to migrate a KDE3 profile to Trinity."
# Are we in X? Display an X dialog explaining breakage.
if [ "$USER_DIR" = "$HOME" ] && [ "$DISPLAY" != "" ]; then
MESSAGE="${MESSAGE}\n\nSelecting the Continue button means retaining the KDE3 profile and\nbreaking the sym link. With the sym link broken, run the migratekde3\nscript before restarting Trinity to migrate a KDE3 profile or\nallow Trinity to create a fresh profile."
printf "%b" "$MESSAGE" | xmessage -center -file - -buttons Continue,Quit > /dev/null 2>/dev/null
EXIT_CODE="$?"
unset TDEHOME_LINK
if [ "$EXIT_CODE" = "102" ]; then
# User selected the Quit button: quit this script and exit X.
unset PROFILE_DIR
Message_Prefix
echo "The user chose to quit."
exit 1
else
# User selected the Continue button: continue this script and start TDE.
Message_Prefix
echo "The user chose to continue, which will break the sym link."
BREAK_SYMLINK="true"
fi
else
echo
printf "%b" "$MESSAGE"
echo
Wait_For_Response "Break the sym link now?"
Proceed_From_Response
BREAK_SYMLINK="true"
fi
if [ "$BREAK_SYMLINK" = "true" ]; then
unlink "$USER_DIR/.trinity" 2>/dev/null
if [ "`readlink \"$USER_DIR/.trinity\"`" = "" ]; then
MESSAGE="Sym link broken. With the sym link broken, run the migratekde3\nscript before restarting Trinity to migrate a KDE3 profile or\nallow Trinity to create a fresh profile."
if [ "$USER_DIR" = "$HOME" ] && [ "$DISPLAY" != "" ]; then
Message_Prefix
fi
printf "%b" "$MESSAGE"
echo
else
MESSAGE="Unable to break the sym link. Check file and directory privileges. Quitting."
if [ "$USER_DIR" = "$HOME" ] && [ "$DISPLAY" != "" ]; then
Message_Prefix
fi
echo "$MESSAGE"
echo
fi
fi
unset PROFILE_DIR
unset TDEHOME_LINK
exit 1
fi
unset TDEHOME_LINK
R14_UPDATED="`$TDEDIR/bin/kreadconfig --file "$PROFILE_DIR/share/config/kdeglobals" --group "R14 XDG Updates" --key Updated`"
if [ "$R14_UPDATED" != "true" ] || [ "$FORCE" = "true" ]; then
if [ "$R14_UPDATED" != "true" ] && [ "$R14_UPDATED" != "false" ] && [ "$R14_UPDATED" != "" ]; then
Message_Prefix
echo "The r14-xdg-update script has been run at least once."
Message_Prefix
echo "The error code is $R14_UPDATED."
echo
MESSAGE="The r14-xdg-update script has been run at least once.\n\nThe script is not successfully updating.\n\nThe script will run with each login until corrected.\n\nPlease contact an administrator or take appropriate\nadmininstrative action to correct the problem.\n\nThe error code is $R14_UPDATED."
# Are we in X? Display an X dialog explaining breakage.
if [ "$USER_DIR" = "$HOME" ] && [ "$DISPLAY" != "" ]; then
printf "%b" "$MESSAGE" | xmessage -center -file - -buttons Continue,Quit > /dev/null 2>/dev/null
if [ "$?" = "102" ]; then
# User select the Quit button: quit this script.
unset PROFILE_DIR
unset R14_UPDATED
exit 1
fi
fi
fi
else
echo "This script has been run at least once previously. To run manually pass the 'force' parameter."
exit 0
fi
# Trap when the user runs this script while in a Trinity session.
# Most files can be updated "live" but some can't, such as kdeglobals.
if [ "$USER_DIR" = "$HOME" ]; then
if [ "$TDE_FULL_SESSION" != "" ] || [ "$TDE_SESSION_UID" != "" ]; then
MESSAGE="You are running this script from within a Trinity session.\n\nMost files can be updated \"live\" but some cannot, such as kdeglobals.\n\nThis script might complete successfully and might not."
# Are we in X? Display an X dialog explaining breakage.
if [ "$USER_DIR" = "$HOME" ] && [ "$DISPLAY" != "" ]; then
# As we are in a Trinity session then use kdialog.
kdialog --title "R14-XDG-Update" --warningyesno "${MESSAGE}\n\nContinue?"
if [ "$?" -gt "0" ]; then
unset PROFILE_DIR
exit 0
fi
else
Message_Prefix
printf "%b" "$MESSAGE\n\n${WARNING_MESSAGE}"
Wait_For_Response "Continue?"
Proceed_From_Response
fi
fi
fi
Message_Prefix
echo "Updating *.desktop files."
find "$PROFILE_DIR" -name "*.desktop" -exec sed -i 's|X-KDE-|X-TDE-|g' {} \; 2>/dev/null
find "$PROFILE_DIR" -name "*.desktop" -exec sed -i 's|KDE\;|TDE\;|g' {} \; 2>/dev/null
find "$USER_DIR/.local" -name "*.desktop" -exec sed -i 's|X-KDE-|X-TDE-|g' {} \; 2>/dev/null
find "$USER_DIR/.local" -name "*.desktop" -exec sed -i 's|KDE\;|TDE\;|g' {} \; 2>/dev/null
Message_Prefix
echo "Updating references of $TDEDIR/share/applications/kde to share/applications/tde."
# Exclude KMail mail files --- we don't want to touch those files.
if [ -d "$PROFILE_DIR/share/apps/kmail/mail" ]; then
find "$PROFILE_DIR" -path "$PROFILE_DIR/share/apps/kmail/mail" -prune -o -type f -exec sed -i "s|$TDEDIR/share/applications/kde|$TDEDIR/share/applications/tde|g" {} \; 2>/dev/null
else
find "$PROFILE_DIR" -type f -exec sed -i "s|$TDEDIR/share/applications/kde|$TDEDIR/share/applications/tde|g" {} \; 2>/dev/null
fi
# Preserve keyboard shortcuts and input actions.
if [ -r "$PROFILE_DIR/share/config/khotkeysrc" ]; then
Message_Prefix
echo "Updating user-defined keyboard shortcuts in khotkeysrc."
sed -i 's|CommandURL=kde-|CommandURL=tde-|g' "$PROFILE_DIR/share/config/khotkeysrc" 2>/dev/null
sed -i 's|K Menu - kde-|TDE Menu - tde-|g' "$PROFILE_DIR/share/config/khotkeysrc" 2>/dev/null
sed -i 's|Name=K Menu|Name=TDE Menu|g' "$PROFILE_DIR/share/config/khotkeysrc" 2>/dev/null
sed -i 's|in KDE stands|in TDE stands|g' "$PROFILE_DIR/share/config/khotkeysrc" 2>/dev/null
sed -i 's| use KDE| use TDE|g' "$PROFILE_DIR/share/config/khotkeysrc" 2>/dev/null
Message_Prefix
echo "Updating some text strings in khotkeysrc."
sed -i 's|Go to KDE Website|Go to TDE Website|g' "$PROFILE_DIR/share/config/khotkeysrc" 2>/dev/null
sed -i 's|www\.kde\.org|www\.trinitydesktop\.org|g' "$PROFILE_DIR/share/config/khotkeysrc" 2>/dev/null
sed -i 's|KDE3\.1|TDE|g' "$PROFILE_DIR/share/config/khotkeysrc" 2>/dev/null
sed -i 's|kde32b1|trinity2b1|g' "$PROFILE_DIR/share/config/khotkeysrc" 2>/dev/null
sed -i 's|kde321|trinity21|g' "$PROFILE_DIR/share/config/khotkeysrc" 2>/dev/null
fi
# Fix the some of the same text strings in kglobalshortcutsrc.
Message_Prefix
echo "Updating some text strings in kglobalshortcutsrc."
sed -i 's|Go to KDE Website|Go to TDE Website|g' "$PROFILE_DIR/share/config/kglobalshortcutsrc" 2>/dev/null
sed -i 's|www\.kde\.org|www\.trinitydesktop\.org|g' "$PROFILE_DIR/share/config/kglobalshortcutsrc" 2>/dev/null
sed -i 's|KDE3\.1|TDE|g' "$PROFILE_DIR/share/config/kglobalshortcutsrc" 2>/dev/null
# Preserve app preferences.
if [ -r $PROFILE_DIR/share/config/profilerc ]; then
Message_Prefix
echo "Updating user-defined app preferences in profilerc."
sed -i 's|Application=kde-|Application=tde-|g' "$PROFILE_DIR/share/config/profilerc" 2>/dev/null
fi
# Preserve kicker/panel icons.
if [ -r $PROFILE_DIR/share/config/kickerrc ]; then
Message_Prefix
echo "Updating kicker/panel customizations in kickerrc."
if [ -r "$PROFILE_DIR/share/config/kickerrc" ]; then
sed -i 's|StorageId\[\$e\]=kde-|StorageId\[\$e\]=tde-|g' "$PROFILE_DIR/share/config/kickerrc" 2>/dev/null
else
Message_Prefix
echo "kickerrc does not exist."
fi
fi
# Preserve Quick Launch icons.
# There should only be one configuration file, but old KDE3 remnant files might exist ofr users who
# migrated from KDE3. We don't care about those files, but we still need to update the correct configuration file.
Message_Prefix
echo "Updating Quick Launch applet."
if [ -r "$PROFILE_DIR/share/config/kickerrc" ]; then
QUICK_LAUNCH_CONFIG="`grep launcher_panelapplet $PROFILE_DIR/share/config/kickerrc | awk -F = '{print $2}'`"
if [ "$QUICK_LAUNCH_CONFIG" != "" ]; then
sed -i 's|,kde-|,tde-|g' "$PROFILE_DIR/share/config/$QUICK_LAUNCH_CONFIG" 2>/dev/null
else
Message_Prefix
echo "Quick Launch is not installed."
fi
else
Message_Prefix
echo "Quick Launch is not installed."
fi
Message_Prefix
echo "Updating Quanta Plus plugins.rc."
if [ -r $PROFILE_DIR/share/apps/quanta/plugins.rc ]; then
sed -i 's|FileName=kde3|FileName=trinity|g' "$PROFILE_DIR/share/apps/quanta/plugins.rc" 2>/dev/null
else
Message_Prefix
echo "$PROFILE_DIR/share/apps/quanta/plugins.rc does not exist."
fi
# Update sym link files in $USER_DIR/.trinity/Autostart.
if [ -d "$PROFILE_DIR/Autostart" ]; then
( cd "$PROFILE_DIR/Autostart"
Message_Prefix
echo "Updating Autostart files."
for i in `find . -type l`; do
LINK="`readlink $i`"
LINK_PATH="`dirname $LINK`"
LINK_NAME="`basename $LINK`"
if [ -n "`echo $LINK_PATH | grep \"$TDEDIR/share/applications/kde\"`" ]; then
NEW_LINK_PATH="`echo \"$LINK_PATH\" | sed 's|/share/applications/kde|/share/applications/tde|'`"
fi
unlink $i
ln -sf "$NEW_LINK_PATH/$LINK_NAME" "$LINK_NAME"
if [ "$?" != "0" ]; then
Message_Prefix
echo "There was an error with creating a new sym link for $LINK." 1>&2
KDEGLOBALS_KEY_VALUE="autostart"
fi
done
)
else
Message_Prefix
echo "Autostart directory not found."
fi
# Update the user's customized menu.
if [ -r $USER_DIR/.config/menus/applications-kmenuedit.menu ]; then
sed -i 's|<Filename>kde-|<Filename>tde-|g' $USER_DIR/.config/menus/applications-kmenuedit.menu
fi
# Perform some nominal update validations.
# First clean house from any previous failures.
if [ -d "$CACHE_DIR" ]; then
rm -f ${CACHE_DIR}/${SCRIPT_NAME}-test*.txt 2>/dev/null
else
# Create this directory in case the migratekde3 script was run immediately
# before this script, which means the cache directory will not yet exist.
mkdir "$CACHE_DIR"
fi
# This first test includes *.desktop files in the profile Autostart directory.
TEST_NUM="1"
R14_UPDATE_TEST1=""
find "$PROFILE_DIR" -name "*.desktop" -exec grep -l "X-KDE" {} \; &>${CACHE_DIR}/${SCRIPT_NAME}-test${TEST_NUM}.txt
if [ -s ${CACHE_DIR}/${SCRIPT_NAME}-test${TEST_NUM}.txt ]; then
R14_UPDATE_TEST1="failed"
MESSAGE="Some Trinity profile R14 XDG compliance updates failed.\n\n(Check *.desktop files for 'X-KDE' in\n${CACHE_DIR}/${SCRIPT_NAME}-test${TEST_NUM}.txt.)"
Validation_Failure
else
rm -f ${CACHE_DIR}/${SCRIPT_NAME}-test${TEST_NUM}.txt 2>/dev/null
fi
TEST_NUM="2"
R14_UPDATE_TEST2=""
find $PROFILE_DIR -name "*.desktop" -exec grep -l "KDE;" {} \; &>${CACHE_DIR}/${SCRIPT_NAME}-test${TEST_NUM}.txt
if [ -s ${CACHE_DIR}/${SCRIPT_NAME}-test${TEST_NUM}.txt ]; then
R14_UPDATE_TEST2="failed"
MESSAGE="Some Trinity profile R14 XDG compliance updates failed.\n\n(Check *.desktop files for 'KDE;' in\n${CACHE_DIR}/${SCRIPT_NAME}-test${TEST_NUM}.txt.)"
Validation_Failure
else
rm -f ${CACHE_DIR}/${SCRIPT_NAME}-test${TEST_NUM}.txt 2>/dev/null
fi
TEST_NUM="3"
R14_UPDATE_TEST3=""
if [ -d "$PROFILE_DIR/share/apps/kmail/mail" ]; then
find "$PROFILE_DIR" -path "$PROFILE_DIR/share/apps/kmail/mail" -prune -o -type f -exec grep -l "$TDEDIR/share/applications/kde" {} \; &>${CACHE_DIR}/${SCRIPT_NAME}-test${TEST_NUM}.txt
else
find "$PROFILE_DIR" -type f -exec grep -l "$TDEDIR/share/applications/kde" {} \; &>${CACHE_DIR}/${SCRIPT_NAME}-test${TEST_NUM}.txt
fi
if [ -s ${CACHE_DIR}/${SCRIPT_NAME}-test${TEST_NUM}.txt ]; then
R14_UPDATE_TEST3="failed"
MESSAGE="Some Trinity profile R14 XDG compliance updates failed.\n\n(Check files for '$TDEDIR/share/applications/kde' in\n${CACHE_DIR}/${SCRIPT_NAME}-test${TEST_NUM}.txt.)"
Validation_Failure
else
rm -f ${CACHE_DIR}/${SCRIPT_NAME}-test${TEST_NUM}.txt 2>/dev/null
fi
TEST_NUM="4"
R14_UPDATE_TEST4=""
if [ -r "$PROFILE_DIR/share/config/khotkeysrc" ]; then
grep "CommandURL=kde-" "$PROFILE_DIR/share/config/khotkeysrc" &>${CACHE_DIR}/${SCRIPT_NAME}-test${TEST_NUM}.txt
if [ -s ${CACHE_DIR}/${SCRIPT_NAME}-test${TEST_NUM}.txt ]; then
R14_UPDATE_TEST4="failed"
MESSAGE="Some Trinity profile R14 XDG compliance updates failed.\n\n(Check khotkeysrc for 'CommandURL=kde-' in\n${CACHE_DIR}/${SCRIPT_NAME}-test${TEST_NUM}.txt.)"
else
rm -f ${CACHE_DIR}/${SCRIPT_NAME}-test${TEST_NUM}.txt 2>/dev/null
fi
fi
TEST_NUM="5"
R14_UPDATE_TEST5=""
if [ -r "$PROFILE_DIR/share/config/khotkeysrc" ]; then
grep "K Menu - kde-" "$PROFILE_DIR/share/config/khotkeysrc" &>${CACHE_DIR}/${SCRIPT_NAME}-test${TEST_NUM}.txt
if [ -s ${CACHE_DIR}/${SCRIPT_NAME}-test${TEST_NUM}.txt ]; then
R14_UPDATE_TEST5="failed"
MESSAGE="Some Trinity profile R14 XDG compliance updates failed.\n\n(Check khotkeysrc for 'K Menu - kde-' in\n${CACHE_DIR}/${SCRIPT_NAME}-test${TEST_NUM}.txt.)"
Validation_Failure
else
rm -f ${CACHE_DIR}/${SCRIPT_NAME}-test${TEST_NUM}.txt 2>/dev/null
fi
fi
TEST_NUM="6"
R14_UPDATE_TEST6=""
if [ -r $PROFILE_DIR/share/config/profilerc ]; then
grep "Application=kde-" "$PROFILE_DIR/share/config/profilerc" &>${CACHE_DIR}/${SCRIPT_NAME}-test${TEST_NUM}.txt
if [ -s ${CACHE_DIR}/${SCRIPT_NAME}-test${TEST_NUM}.txt ]; then
R14_UPDATE_TEST6="failed"
MESSAGE="Some Trinity profile R14 XDG compliance updates failed.\n\n(Check profilerc for 'Application=kde-' in\n${CACHE_DIR}/${SCRIPT_NAME}-test${TEST_NUM}.txt.)"
Validation_Failure
else
rm -f ${CACHE_DIR}/${SCRIPT_NAME}-test${TEST_NUM}.txt 2>/dev/null
fi
fi
TEST_NUM="7"
R14_UPDATE_TEST7=""
if [ -r $PROFILE_DIR/share/config/kickerrc ]; then
grep "StorageId\[\$e\]=kde-" "$PROFILE_DIR/share/config/kickerrc" &>${CACHE_DIR}/${SCRIPT_NAME}-test${TEST_NUM}.txt
if [ -s ${CACHE_DIR}/${SCRIPT_NAME}-test${TEST_NUM}.txt ]; then
R14_UPDATE_TEST7="failed"
MESSAGE="Some Trinity profile R14 XDG compliance updates failed.\n\n(Check kickerrc for 'StorageId[$e]=kde-' in\n${CACHE_DIR}/${SCRIPT_NAME}-test${TEST_NUM}.txt.)"
Validation_Failure
else
rm -f ${CACHE_DIR}/${SCRIPT_NAME}-test${TEST_NUM}.txt 2>/dev/null
fi
fi
TEST_NUM="8"
R14_UPDATE_TEST8=""
if [ "$QUICK_LAUNCH_CONFIG" != "" ]; then
grep "kde-" "$PROFILE_DIR/share/config/$QUICK_LAUNCH_CONFIG" &>${CACHE_DIR}/${SCRIPT_NAME}-test${TEST_NUM}.txt
if [ -s ${CACHE_DIR}/${SCRIPT_NAME}-test${TEST_NUM}.txt ]; then
R14_UPDATE_TEST8="failed"
MESSAGE="Some Trinity profile R14 XDG compliance updates failed.\n\n(Check $QUICK_LAUNCH_CONFIG for 'kde-' in\n${CACHE_DIR}/${SCRIPT_NAME}-test${TEST_NUM}.txt.)"
Validation_Failure
else
rm -f ${CACHE_DIR}/${SCRIPT_NAME}-test${TEST_NUM}.txt 2>/dev/null
fi
fi
TEST_NUM="9"
R14_UPDATE_TEST9=""
if [ -r $USER_DIR/.config/menus/applications-kmenuedit.menu ]; then
grep "<Filename>kde-" "$USER_DIR/.config/menus/applications-kmenuedit.menu" &>${CACHE_DIR}/${SCRIPT_NAME}-test${TEST_NUM}.txt
if [ -s ${CACHE_DIR}/${SCRIPT_NAME}-test${TEST_NUM}.txt ]; then
R14_UPDATE_TEST9="failed"
MESSAGE="Some Trinity profile R14 XDG compliance updates failed.\n\n(Check applications-kmenuedit.menu for '<Filename>kde-' in\n${CACHE_DIR}/${SCRIPT_NAME}-test${TEST_NUM}.txt.)"
Validation_Failure
else
rm -f ${CACHE_DIR}/${SCRIPT_NAME}-test${TEST_NUM}.txt 2>/dev/null
fi
fi
if [ "$R14_UPDATE_TEST1" = "" ] && [ "$R14_UPDATE_TEST2" = "" ] && [ "$R14_UPDATE_TEST3" = "" ] \
&& [ "$R14_UPDATE_TEST4" = "" ] && [ "$R14_UPDATE_TEST5" = "" ] && [ "$R14_UPDATE_TEST6" = "" ] \
&& [ "$R14_UPDATE_TEST7" = "" ] && [ "$R14_UPDATE_TEST8" = "" ] && [ "$R14_UPDATE_TEST9" = "" ]; then
$TDEDIR/bin/kwriteconfig --file "$PROFILE_DIR/share/config/kdeglobals" --group "R14 XDG Updates" --key Updated --type bool "true"
Message_Prefix
echo "R14 XDG updates completed successfully."
else
# Don't use the --type parameter here because the value no longer is boolean.
$TDEDIR/bin/kwriteconfig --file "$PROFILE_DIR/share/config/kdeglobals" --group "R14 XDG Updates" --key Updated "$KDEGLOBALS_KEY_VALUE"
MESSAGE="The r14-xdg-update script did not complete successfully.\n\nThe script will run with each login until corrected.\n\nPlease contact an administrator or take appropriate\nadmininstrative action to correct the problem.\n\nThe error code is $KDEGLOBALS_KEY_VALUE.\n\nBe sure to check file and directory permissions."
# Are we in X? Display an X dialog explaining breakage.
if [ "$USER_DIR" = "$HOME" ] && [ "$DISPLAY" != "" ]; then
printf "%b" "$MESSAGE" | xmessage -center -file - -buttons OK > /dev/null 2>/dev/null
else
Message_Prefix
printf "%b" "$MESSAGE"
fi
fi
unset USER_DIR
unset PROFILE_DIR
unset R14_UPDATED
unset R14_UPDATE_TEST1
unset R14_UPDATE_TEST2
unset R14_UPDATE_TEST3
unset R14_UPDATE_TEST4
unset R14_UPDATE_TEST5
unset R14_UPDATE_TEST6
unset KDEGLOBALS_KEY_VALUE
unset TEST_NUM
exit 0